## START: Set by rpmautospec
## (rpmautospec version 0.6.0)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 5;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond_without check

Name:       stgit
Version:    2.4.0
Release:    %autorelease
Summary:    Stack-based patch management for Git

SourceLicense:    GPL-2.0-only
# (Apache-2.0 OR MIT) AND BSD-3-Clause
# (MIT OR Apache-2.0) AND Unicode-DFS-2016
# 0BSD OR MIT OR Apache-2.0
# Apache-2.0
# Apache-2.0 OR BSL-1.0
# Apache-2.0 OR MIT
# Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT
# BSD-3-Clause
# GPL-2.0-only
# MIT
# MIT OR Apache-2.0
# MIT OR Apache-2.0 OR Zlib
# MIT OR Zlib OR Apache-2.0
# Unlicense OR MIT
# Zlib OR Apache-2.0 OR MIT
License:        Apache-2.0 AND BSD-3-Clause AND GPL-2.0-only AND MIT AND Unicode-DFS-2016 AND (0BSD OR Apache-2.0 OR MIT) AND (Apache-2.0 OR BSL-1.0) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND (Apache-2.0 OR MIT OR Zlib) AND (MIT OR Unlicense)

URL:        https://stacked-git.github.io/
Source:     https://github.com/stacked-git/%{name}/releases/download/v%{version}/%{name}-%{version}.tar.gz
# Update gix to a newer version that is packaged in Fedora
Patch:      stgit-fix-metadata.diff
# Patch from upstream replacing calls to deprecated methods of indexmap
Patch:      0001-refactor-use-non-deprecated-indexmap-methods.patch

BuildRequires:  cargo-rpm-macros
BuildRequires:  asciidoc
BuildRequires:  make
BuildRequires:  perl
BuildRequires:  xmlto

%if %{with check}
BuildRequires:  procps-ng
BuildRequires:  git-core
BuildRequires:  git-email
%endif

Requires:   git-core
Requires:   git-email
Requires:   emacs-filesystem
Requires:   vim-filesystem

%description
Stacked Git, StGit for short, is an application for managing Git commits as a
stack of patches.

With a patch stack workflow, multiple patches can be developed concurrently and
efficiently, with each patch focused on a single concern, resulting in both a
clean Git commit history and improved productivity.

%prep
%autosetup -n %{name}-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
# The build.rs file only adds an environment variable with the current git
# hash. The tarball is not a git repo so the build script doesn't do anything.
# This also means, it doesn't emit any rerun-if* directives. This makes cargo
# rebuild the whole application if any file changes. This causes frequent
# recompiles in the documentation, etc. leading to very long build times.
rm build.rs
# The Makefile uses some combination of --locked and --offline which only work
# with Cargo.lock present. Regenerating it after cargo_prep should be fine.
%{__cargo} generate-lockfile

make all CARGO="%{__cargo}" STG_PROFILE=rpm
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies

%install
make install install-man install-completion install-contrib CARGO="%{__cargo}" STG_PROFILE=rpm DESTDIR=$RPM_BUILD_ROOT prefix=%{_prefix}

# Install data files
install -m 644 -D contrib/stgbashprompt.sh $RPM_BUILD_ROOT%{_datadir}/%{name}/contrib/stgbashprompt.sh

%if %{with check}
%check
%cargo_test
# Use the same profile to prevent a rebuild of the application
make test CARGO="%{__cargo}" STG_PROFILE=rpm
%endif

%files
%license COPYING
%license LICENSE.dependencies
%doc CHANGELOG.md
%doc README.md
%{_bindir}/stg
%{_mandir}/man1/stg*
%{_datadir}/%{name}/
%{_datadir}/emacs/site-lisp/stgit.el
%{_datadir}/vim/vimfiles/ftdetect/stg.vim
%{_datadir}/vim/vimfiles/syntax/stg*.vim
%{bash_completions_dir}/stg
%{fish_completions_dir}/stg.fish
%{zsh_completions_dir}/_stg

%changelog
## START: Generated by rpmautospec
* Fri Feb 16 2024 Felix Maurer <fmaurer@redhat.com> - 2.4.0-5
- Fix usage of deprecated functions from indexmap

* Fri Feb 16 2024 Felix Maurer <fmaurer@redhat.com> - 2.4.0-4
- Address review comments
- Require cargo-rpm-macros instead of rust-packaging
- Conditionally require test requirements
- Fix License tag
- Require emacs-filesystem
- Run cargo tests
- Use the same cargo everywhere to prevent rebuilds

* Fri Feb 16 2024 Felix Maurer <fmaurer@redhat.com> - 2.4.0-3
- Patch to newer gix

* Fri Feb 16 2024 Felix Maurer <fmaurer@redhat.com> - 2.4.0-2
- Enable tests

* Wed Jan 17 2024 Felix Maurer <fmaurer@redhat.com> - 2.4.0-1
- Update to 2.4.0 (Rust based)

* Sat Jan 21 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Sat Jul 23 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Mon Jun 13 2022 Python Maint <python-maint@redhat.com> - 1.5-2
- Rebuilt for Python 3.11

* Mon Feb 21 2022 Peter Schiffer <peter+fedora@pschiffer.eu> - 1.5-1
- Updated to 1.5
- resolves: #2047946

* Sat Jan 22 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.4-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Sun Nov 07 2021 Peter Schiffer <peter+fedora@pschiffer.eu> - 1.4-1
- Updated to 1.4
- resolves: #2007998

* Fri Jul 23 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Fri Jun 04 2021 Python Maint <python-maint@redhat.com> - 1.1-2
- Rebuilt for Python 3.10

* Sat May 29 2021 Peter Schiffer <peter+fedora@pschiffer.eu> - 1.1-1
- Updated to 1.1
- resolves: #1955877

* Fri Feb 19 2021 Peter Schiffer <peter+fedora@pschiffer.eu> - 1.0-1
- Updated to 1.0
- resolves: #1926050

* Wed Jan 27 2021 Fedora Release Engineering <releng@fedoraproject.org> - 0.23-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Mon Jan 11 2021 Zane Bitter <zbitter@redhat.com> - 0.23-4
- Fix bash completion

* Fri Jan 08 2021 Tom Stellard <tstellar@redhat.com> - 0.23-3
- Add BuildRequires: make

* Wed Jul 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.23-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Sat Jun 13 2020 Peter Schiffer <peter+fedora@pschiffer.eu> - 0.23-1
- Updated to 0.23
- resolves: #1846723

* Tue May 26 2020 Miro Hrončok <miro@hroncok.cz> - 0.22-2
- Rebuilt for Python 3.9

* Wed Mar 11 2020 Peter Schiffer <peter+fedora@pschiffer.eu> - 0.22-1
- Updated to 0.22
- resolves: #1811808

* Fri Jan 31 2020 Fedora Release Engineering <releng@fedoraproject.org> - 0.21-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Wed Nov 20 2019 Peter Schiffer <peter+fedora@pschiffer.eu> - 0.21-1
- Update to 0.21
- resolves: #1766354

* Mon Oct 14 2019 Peter Schiffer <peter+fedora@pschiffer.eu> - 0.20-1
- Updated to 0.20
- resolves: #1758807

* Thu Oct 03 2019 Miro Hrončok <miro@hroncok.cz> - 0.19-4
- Rebuilt for Python 3.8.0rc1 (#1748018)

* Mon Aug 19 2019 Miro Hrončok <miro@hroncok.cz> - 0.19-3
- Rebuilt for Python 3.8

* Sat Jul 27 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.19-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Wed Jun 05 2019 Dan Horák <dan@danny.cz> - 0.19-1
- updated to 0.19 - drop upstreamed patch - switch to Python3

* Sun Feb 03 2019 Fedora Release Engineering <releng@fedoraproject.org> - 0.18-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Mon Jan 28 2019 Igor Gnatenko <ignatenkobrain@fedoraproject.org> - 0.18-5
- Remove obsolete Group tag

* Tue Jul 17 2018 Miro Hrončok <miro@hroncok.cz> - 0.18-4
- Update Python macros to new packaging standards

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.18-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.18-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Fri Nov 24 2017 Peter Schiffer <pschiffe@redhat.com> - 0.18-1
- Updated to 0.18
- resolves: #1513726

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.17.1-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.17.1-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Jul 19 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.17.1-6
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_
  Packages

* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.17.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jun 19 2015 Dennis Gilmore <dennis@ausil.us> - 0.17.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Jun 08 2014 Dennis Gilmore <dennis@ausil.us> - 0.17.1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Oct 17 2013 Peter Schiffer <pschiffe@redhat.com> - 0.17.1-2
- Added dependency on git-email package
- resolves: #1004478 added dependency on git-email package, so the stg mail
  command can function properly

* Thu Oct 17 2013 Peter Schiffer <pschiffe@redhat.com> - 0.17.1-1
- Updated to 0.17.1
- resolves: #1014240

* Wed Jul 31 2013 Peter Schiffer <pschiffe@redhat.com> - 0.17-3
- Fix dirty index errors when resolving conflicts

* Tue Jul 30 2013 Peter Schiffer <pschiffe@redhat.com> - 0.17-2
- Included vim syntax highlighting

* Thu Jul 04 2013 Peter Schiffer <pschiffe@redhat.com> - 0.17-1
- Updated to 0.17
- resolves: #979618

* Fri Feb 15 2013 Dennis Gilmore <dennis@ausil.us> - 0.16-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Tue Dec 04 2012 Peter Schiffer <pschiffe@redhat.com> - 0.16-4
- resolves: #872651 fixed regression when "stg new" command was ignoring
  patchdescr.tmpl file

* Mon Oct 22 2012 Peter Schiffer <pschiffe@redhat.com> - 0.16-3
- un-orphaned package - updated to 0.16

* Sat Jan 14 2012 Dennis Gilmore <dennis@ausil.us> - 0.15-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Dec 06 2011 Todd Zullinger <tmz@pobox.com> - 0.15-1
- Resolves: rhbz#530877 bump stgit to 0.15

* Wed Feb 09 2011 Dennis Gilmore <dennis@ausil.us> - 0.14.3-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Thu Jul 29 2010 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.14.3-9
- dist-git conversion

* Thu Jul 22 2010 dmalcolm <dmalcolm@fedoraproject.org> - 0.14.3-8
- Rebuilt for
  https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Wed Nov 25 2009 Bill Nottingham <notting@fedoraproject.org> - 0.14.3-7
- Fix typo that causes a failure to update the common directory. (releng
  #2781)

* Mon Jul 27 2009 Jesse Keating <jkeating@fedoraproject.org> - 0.14.3-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Jesse Keating <jkeating@fedoraproject.org> - 0.14.3-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Thu Dec 04 2008 Ignacio Vazquez-Abrams <ivazquez@fedoraproject.org> - 0.14.3-4
- Rebuild for Python 2.6

* Tue Dec 02 2008 jbowes <jbowes@fedoraproject.org> - 0.14.3-3
- try and make the summary text better

* Sat Nov 29 2008 Ignacio Vazquez-Abrams <ivazquez@fedoraproject.org> - 0.14.3-2
- Rebuild for Python 2.6

* Tue Jun 17 2008 jbowes <jbowes@fedoraproject.org> - 0.14.3-1
- Update to 0.14.3

* Wed Mar 26 2008 jbowes <jbowes@fedoraproject.org> - 0.14.2-1
- update to 0.14.2

* Thu Dec 13 2007 jbowes <jbowes@fedoraproject.org> - 0.14.1-2
- Add BR for git-core

* Thu Dec 13 2007 jbowes <jbowes@fedoraproject.org> - 0.14.1-1
- Update to 0.14.1

* Fri Aug 24 2007 jbowes <jbowes@fedoraproject.org> - 0.13-2
- mark license as gplv2

* Sun Aug 05 2007 jbowes <jbowes@fedoraproject.org> - 0.13-1
- update to 0.13

* Wed Apr 25 2007 jbowes <jbowes@fedoraproject.org> - 0.12.1-2
- Use datadir macro

* Wed Apr 25 2007 jbowes <jbowes@fedoraproject.org> - 0.12.1-1
- Initial import
## END: Generated by rpmautospec
